/**
 * Mutual Exclusion via Message Token
 *
 * author: Patrick Trentin <patrick.trentin@unitn.it>
 */

mtype = {MSG};

chan sharing = [1] of {mtype};

proctype mutex() {

    printf("Process %d has started.\n", _pid);

trying:
    sharing?MSG;

critical:
    skip;
    printf("Process %d entered critical section.\n", _pid);

exit:
    sharing!MSG;
    printf("Process %d exited critical section.\n", _pid);

    goto trying;
}

init {
    sharing!MSG;
    atomic {
      run mutex();
      run mutex();
      run mutex();
    }
}

#define c0 (mutex[1]@critical)
#define c1 (mutex[2]@critical)
#define c2 (mutex[3]@critical)
#define t0 (mutex[1]@trying)
#define t1 (mutex[2]@trying)
#define t2 (mutex[3]@trying)
#define l0 (_last == 1)
#define l1 (_last == 2)
#define l2 (_last == 3)
#define f0 ([] <> l0)
#define f1 ([] <> l1)
#define f2 ([] <> l2)

ltl p1 { []   !(c0  &&  c1)  && !(c0 && c2) && !(c1 && c2)}
ltl p2 { []((t0 || t1 || t2) -> <> (c0 || c1 || c2)) }
ltl p3 {
        (f0 -> [](t0 -> <> c0))
        &&
        (f1 -> [](t1 -> <> c1))
        &&
        (f2 -> [](t2 -> <> c2))
        };
ltl p4 { []((t0 -> <>c0) && (t1 -> <>c1) && (t2 -> <>c2))}
