/**
 * Jumping Array
 *
 * author: Patrick Trentin <patrick.trentin@unitn.it>
 *
 */

#define N 11
mtype = { TOKEN };
int ar[N];

proctype moveOne(chan c; int j)
{
  bool found;
  do
    :: atomic {
      c?TOKEN(found) ->
      if
        :: found ->
          break;
        :: else ->
          ar[j] = 0;
          if
             :: j = (j+1)%N;
             :: j = (j-1) -> // account for negative values
                 if
                   :: j < 0 -> j = j + N;
                   :: else -> skip;
                 fi;
             :: j = j;
          fi;
          ar[j] = 1;
          printf("moveOne: jumped to ar[%d]\n", j);
      fi;
      }
  od;
}

proctype sweepStep2(chan c)
{
  int steps = 0;
  int i = 0;
  bool found = false;
  do
    :: true ->
      steps++;
      int v = ar[i];
      if
        :: ar[i] == 1 ->
          printf("sweepStep2: found 1 at ar[%d]\n", i);
          c!TOKEN(true); // terminate moveOne
          break;
        :: ar[i] == 0 ->
          i = (i + 2) % N;
          c!TOKEN(false); // update 1's location
      fi
  od;
end:
  printf("sweepStep2: search took %d steps.\n", steps);
}

init {
  int j = 0;
  chan synch = [0] of {mtype, bool };

  // put 1 at random location
  if
    :: j = 0;
    :: j = 1;
    :: j = 2;
    :: j = 3;
    :: j = 4;
    :: j = 5;
    :: j = 6;
    :: j = 7;
    :: j = 9;
    :: j = 10;
  fi;
  ar[j] = 1;

  printf("init: placed 1 in ar[%d]\n", j);

  // start the search algorithm
  atomic {
    run moveOne(synch, j);
    run sweepStep2(synch);
  }
}

ltl p1 { <> sweepStep2[2]@end }
