/**
 * Infinite Monkey Theorem
 *
 * author: Patrick Trentin <patrick.trentin@unitn.it>
 *
 */

#define NUM_MONKEYS ('z' - 'a' + 1)

chan typewriter = [0] of { byte };
bool matched = false;

active [NUM_MONKEYS] proctype monkey()
{
    do
        :: typewriter!('a' + _pid)
        :: matched -> break;
    od
}

active proctype reviewer()
{
    byte specimen[13] = { 't', 'o', 'b', 'e', 'o', 'r', 'n', 'o', 't', 't', 'o', 'b', 'e' };
    byte idx, c;

    do
        :: typewriter?c ->
            if
                :: specimen[idx] == c ->
                    printf("Match: %c -- %c\n", specimen[idx], c);
                    idx++;
                    if
                        :: idx == 13 ->
                            matched = true;
                            break;
                        :: else ->
                            skip;
                    fi
                :: else ->
                    idx = 0;
            fi
    od
}

ltl p1 { [] ! matched };

